#include <sys/mman.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>

int main(void)
{
	void *addr;
	int fd;
	size_t page_size;
	
	fd = open("badcode.bin", O_RDWR);
	if (fd < 0) {
		printf("Could not open badcode.bin\n");
		return 1;
	}
	page_size = (size_t)sysconf(_SC_PAGESIZE);
	addr = mmap(NULL, page_size, PROT_READ | PROT_EXEC, MAP_FIXED | MAP_PRIVATE, fd, 0);
	if ((int)addr == -1) {
		printf("mmap failed (%s)\n", strerror(errno));
		return 1;
	}
	printf("sleeping...\n");
	while (1)
		sleep(10);
}
